var stylesheet;
var id_bg, ctx_bg;
var id_bg2, ctx_bg2;
var id_gear0, ctx_gear0;
var id_gear1, ctx_gear1;
var id_gear2, ctx_gear2;
var id_gear3, ctx_gear3;
var id_hour, ctx_hour;
var id_minute, ctx_minute;
var id_second, ctx_second;
var id_anchors, ctx_anchors,id_anchors_shadow, ctx_anchors_shadow;
var id_escape_wheel, ctx_escape_wheel,id_escape_wheel_shadow, ctx_escape_wheel_shadow;
var id_balance, ctx_balance,id_balance_shadow, ctx_balance_shadow;
var id_spring, ctx_spring,id_spring_shadow, ctx_spring_shadow;

var anime_flag = 0;
var gear_num = 8;
var x_gear = new Array(-100, -40, -40, -80, -80,  39,  39, 122);
var y_gear = new Array( 150, 276, 276, 330, 330, 400, 400, 350);
var z_gear = new Array( 100,  10,  60,  10, 100,  10,  40,  10);
var dir_gear = new Array(1, -1, -1, 1, 1, -1, -1, 1);
var move_ang_gear = new Array(0.01, -0.10, -0.10, 0.60, 0.60, -6.0, -6.0, 24);
var current_ang_gear = new Array(-1, 3.3, 3.3, 0.5, 0.5, 4, 4, 4);
var module = new Array(4, 4, 3, 3, 4, 4, 6, 6);
var gear_class_name = new Array("gear1", "gear2", "gear2", "gear3", "gear3", "gear4", "gear4", "escape");
var id_gear = new Array();
var id_gear_s = new Array();
var id_hairspring = new Array();
var id_hairspring_s = new Array();

function init() {
	stylesheet = document.styleSheets.item(0);
	id_bg = document.getElementById("bg");
	ctx_bg = id_bg.getContext("2d");
	id_bg2 = document.getElementById("bg2");
	ctx_bg2 = id_bg2.getContext("2d");
	id_hour = document.getElementById("hour");
	ctx_hour = id_hour.getContext("2d");
	id_minute = document.getElementById("minute");
	ctx_minute = id_minute.getContext("2d");
	id_second = document.getElementById("second");
	ctx_second = id_second.getContext("2d");
	id_anchors = document.getElementById("anchors");
	ctx_anchors = id_anchors.getContext("2d");
	id_anchors_shadow = document.getElementById("anchors_shadow");
	ctx_anchors_shadow = id_anchors_shadow.getContext("2d");
	id_escape_wheel = document.getElementById("escape_wheel");
	ctx_escape_wheel = id_escape_wheel.getContext("2d");
	id_escape_wheel_shadow = document.getElementById("escape_wheel_shadow");
	ctx_escape_wheel_shadow = id_escape_wheel_shadow.getContext("2d");
	id_balance = document.getElementById("balance");
	ctx_balance = id_balance.getContext("2d");
	id_balance_shadow = document.getElementById("balance_shadow");
	ctx_balance_shadow = id_balance_shadow.getContext("2d");
	id_spring = document.getElementById("spring");
	ctx_spring = id_spring.getContext("2d");
	id_spring_shadow = document.getElementById("spring_shadow");
	ctx_spring_shadow = id_spring_shadow.getContext("2d");
  for(i=0; i<gear_num; i++) {
    id_gear[i] = document.getElementById("gear" + i);
    id_gear_s[i] = document.getElementById("gear" + i + "_shadow");
    move_ang_gear[i] *= 1.0;
  }
  for(i=0; i<6; i++) {
    id_hairspring[i] = document.getElementById("hairspring" + i);
    id_hairspring_s[i] = document.getElementById("hairspring" + i + "_shadow");
  }
//  id_anchors.style.position = "absolute";
  id_anchors.style.left = "122px";
  id_anchors.style.top = "268px";
  id_anchors_shadow.style.left = "124px";
  id_anchors_shadow.style.top = "270px";
  //  id_escape_wheel.style.position = "absolute";
  id_escape_wheel.style.left = "122px";
  id_escape_wheel.style.top = "350px";
  id_escape_wheel_shadow.style.left = "124px";
  id_escape_wheel_shadow.style.top = "352px";
  //  id_escape_wheel.style.position = "absolute";
  id_balance.style.left = "122px";
  id_balance.style.top = "172px";
  id_balance_shadow.style.left = "124px";
  id_balance_shadow.style.top = "174px";
  for(i=0; i<6; i++) {
    id_hairspring[i].style.left = "122px";
    id_hairspring[i].style.top = "172px";
    id_hairspring_s[i].style.left = "124px";
    id_hairspring_s[i].style.top = "174px";
  }
  id_spring.style.left = "-100px";
  id_spring.style.top = "150px";
  id_spring_shadow.style.left = "-98px";
  id_spring_shadow.style.top = "152px";
  
  //　短針
  ctx_hour.beginPath();
  ctx_hour.lineWidth = 3;
  ctx_hour.lineCap = "round"
  ctx_hour.fillStyle = "black";
  ctx_hour.moveTo(320, 200);
  ctx_hour.lineTo(320+15, 295);
  ctx_hour.lineTo(320-15, 295);
  ctx_hour.lineTo(320, 200);
  ctx_hour.stroke();
//  ctx_hour.fill();
  
//  ctx_hour.beginPath();
  ctx_hour.moveTo(320, 350);
  ctx_hour.arc(320, 320, 30, 0, 2*Math.PI, false);
  ctx_hour.moveTo(320, 300);
  ctx_hour.arc(320, 320, 20, 0, 2*Math.PI, true);
  ctx_hour.fill();
  
     //分針
  ctx_minute.beginPath();
  ctx_minute.lineWidth = 8;
  ctx_minute.lineCap = "round"
  ctx_minute.strokeStyle = "black";
  ctx_minute.fillStyle = "black";
  ctx_minute.moveTo(320, 100);
  ctx_minute.lineTo(320+10, 295);
  ctx_minute.lineTo(320-10, 295);
  ctx_minute.lineTo(320, 100);
  ctx_minute.stroke();
  ctx_minute.fill();
 
 
  

    //　秒針
  ctx_second.beginPath();
  ctx_second.lineWidth = 7;
  ctx_second.strokeStyle = "red";
  ctx_second.lineCap = "round"
  ctx_second.moveTo(320, 320);
  ctx_second.lineTo(320, 50);
  ctx_second.stroke();
  ctx_second.beginPath();
  ctx_second.fillStyle = "red";
  ctx_second.arc(320, 320, 10, 0, 2 * Math.PI, false);
  ctx_second.fill();
    
    // 文字盤
  ctx_bg.beginPath();
  ctx_bg.lineWidth = 10;
  ctx_bg.strokeStyle = "rgba(0,0,0,0.5)";
  ctx_bg.arc(320, 318, 298, 0, 2 * Math.PI, false);
  ctx_bg.stroke();
  
  ctx_bg.beginPath();
  ctx_bg.lineWidth = 1;
  var grad  = ctx_bg.createRadialGradient(320,800,0,320,800,2900);
  grad.addColorStop(0,"rgba(220,220,220,10)");
  grad.addColorStop(0.2,"rgba(220,220,220,10)");
  grad.addColorStop(0.203,"rgba(240,240,240,10.5)");
	grad.addColorStop(1,"rgba(255,255,255,10.5)");
    ctx_bg.fillStyle = grad;
    ctx_bg.arc(320, 320, 300, 0, 2 * Math.PI, false);
    ctx_bg.fill();
    
    //　目盛り＆数字
//      ctx_bg.beginPath();
		ctx_bg.fillStyle = "black";
		ctx_bg.font = "normal 90px TrebuchetMS";
		ctx_bg.textAlign = "center";
    ctx_bg.shadowColor = "rgba(0, 0, 0, 0.5)";
    ctx_bg.shadowOffsetX = 5;
    ctx_bg.shadowOffsetY = 10;
    ctx_bg.shadowBlur = 5;
//      ctx_bg2.beginPath();
    ctx_bg2.fillStyle = "black";
    ctx_bg2.font = "normal 90px TrebuchetMS";
    ctx_bg2.textAlign = "center";
  for(i=1; i<=60; i++){
		if(i%5 == 0){
		ctx_bg.fillText(i/5, 320+ 230*Math.sin(i*Math.PI/30), 350- 220*Math.cos(i*Math.PI/30));
		ctx_bg2.fillText(i/5, 320+ 230*Math.sin(i*Math.PI/30), 350- 220*Math.cos(i*Math.PI/30));
		}
  }
  for(i=0; i<gear_num; i++) {
    draw_gear(i,module[i]);
//    id_gear[i].style.position = "absolute";
    id_gear[i].style.top = y_gear[i] + "px";
    id_gear[i].style.left = x_gear[i] + "px";
//    id_gear_s[i].style.position = "absolute";
    id_gear_s[i].style.top = y_gear[i] + 2 + "px";
    id_gear_s[i].style.left = x_gear[i] + 2 + "px";
	  id_gear[i].style.webkitTransform = "rotate(" + current_ang_gear[i] + "deg)";
	  id_gear_s[i].style.webkitTransform = "rotate(" + current_ang_gear[i] + "deg)";
  }

  draw_escape_wheel();
  draw_anchors();
  draw_balance();
  draw_hairspring();
  draw_spring();
  
//	setTime();
  setInterval(setTime,500);
}


var cr_hours, cr_minutes, cr_seconds;
var s_rule, m_rule;
function setTime() {
  var i, str;
  get_date = new Date();
  
  if(cr_minutes != get_date.getMinutes()){
    cr_minutes = get_date.getMinutes();
    
    m_angle = (cr_minutes==0)? 360 : cr_minutes*6;
    id_minute.style.transform = "rotate(" + (m_angle+2) + "deg)";
    id_minute.style.webkitTransform = "rotate(" + (m_angle+2) + "deg)";
    id_minute.className = "move";
  }
  if(cr_seconds != get_date.getSeconds()){
    cr_seconds = get_date.getSeconds();
    
    s_angle = (cr_seconds==0)? 360 : cr_seconds*6;
	  id_second.style.transform = "rotate(" + (s_angle+2) + "deg)";
	  id_second.style.webkitTransform = "rotate(" + (s_angle+2) + "deg)";
    id_second.className = "move";
    for(i=0; i<gear_num; i++) {
      id_gear[i].style.webkitTransform = "rotate(" + (current_ang_gear[i]+move_ang_gear[i]*dir_gear[i]) + "deg)";
      id_gear_s[i].style.webkitTransform = "rotate(" + (current_ang_gear[i]+move_ang_gear[i]*dir_gear[i]) + "deg)";
      id_gear[i].className = "gear_move";
      id_gear_s[i].className = "gear_move";
    }
    for(i=0; i<5; i++) {
      stylesheet.deleteRule(stylesheet.cssRules.length -1 );
    }
    str  = "    0% { -webkit-transform: rotate(" + current_ang_gear[7] + "deg);}";
    str += "   40% { -webkit-transform: rotate(" + current_ang_gear[7] + "deg);}";
    str += "   60% { -webkit-transform: rotate(" + (current_ang_gear[7]+move_ang_gear[7]*0.75) + "deg);}";
    str += "  100% { -webkit-transform: rotate(" + (current_ang_gear[7]+move_ang_gear[7]*0.75) + "deg);}";
    stylesheet.addRule("@-webkit-keyframes escape_0", str );
    str  = "    0% { -webkit-transform: rotate(" + current_ang_gear[5] + "deg);}";
    str += "   40% { -webkit-transform: rotate(" + current_ang_gear[5] + "deg);}";
    str += "   60% { -webkit-transform: rotate(" + (current_ang_gear[5]+move_ang_gear[5]*0.75) + "deg);}";
    str += "  100% { -webkit-transform: rotate(" + (current_ang_gear[5]+move_ang_gear[5]*0.75) + "deg);}";
    stylesheet.addRule("@-webkit-keyframes gear4_0", str );
    str  = "    0% { -webkit-transform: rotate(" + current_ang_gear[3] + "deg);}";
    str += "   40% { -webkit-transform: rotate(" + current_ang_gear[3] + "deg);}";
    str += "   60% { -webkit-transform: rotate(" + (current_ang_gear[3]+move_ang_gear[3]*0.75) + "deg);}";
    str += "  100% { -webkit-transform: rotate(" + (current_ang_gear[3]+move_ang_gear[3]*0.75) + "deg);}";
    stylesheet.addRule("@-webkit-keyframes gear3_0", str );
    str  = "    0% { -webkit-transform: rotate(" + current_ang_gear[1] + "deg);}";
    str += "   40% { -webkit-transform: rotate(" + current_ang_gear[1] + "deg);}";
    str += "   60% { -webkit-transform: rotate(" + (current_ang_gear[1]+move_ang_gear[1]*0.75) + "deg);}";
    str += "  100% { -webkit-transform: rotate(" + (current_ang_gear[1]+move_ang_gear[1]*0.75) + "deg);}";
    stylesheet.addRule("@-webkit-keyframes gear2_0", str );
    str  = "    0% { -webkit-transform: rotate(" + current_ang_gear[0] + "deg);}";
    str += "   40% { -webkit-transform: rotate(" + current_ang_gear[0] + "deg);}";
    str += "   60% { -webkit-transform: rotate(" + (current_ang_gear[0]+move_ang_gear[0]*0.75) + "deg);}";
    str += "  100% { -webkit-transform: rotate(" + (current_ang_gear[0]+move_ang_gear[0]*0.75) + "deg);}";
    stylesheet.addRule("@-webkit-keyframes gear1_0", str );
    
    for(i=0; i<8; i++) {
      id_gear[i].className = gear_class_name[i] + "_move0";
      id_gear_s[i].className = gear_class_name[i] + "_move0";
//      current_ang_gear[i] = (current_ang_gear[i] + move_ang_gear[i]) % 360;
    }
    id_anchors.className = "anchors_move0";
    id_anchors_shadow.className = "anchors_move0";
    id_escape_wheel.className = "escape_move0";
    id_escape_wheel_shadow.className = "escape_move0";
    id_balance.className = "balance_move0";
    id_balance_shadow.className = "balance_move0";
    for(i=0; i<6; i++) {
      id_hairspring[i].className = "hairspring" + i + "_move0";
      id_hairspring_s[i].className = "hairspring" + i + "_move0";
    }
  }
  else{
    for(i=0; i<5; i++) {
      stylesheet.deleteRule(stylesheet.cssRules.length -1 );
    }
    str  = "    0% { -webkit-transform: rotate(" + (current_ang_gear[7]+move_ang_gear[7]*0.75) + "deg);}";
    str += "   40% { -webkit-transform: rotate(" + (current_ang_gear[7]+move_ang_gear[7]*0.75) + "deg);}";
    str += "   60% { -webkit-transform: rotate(" + (current_ang_gear[7]+move_ang_gear[7]*1) + "deg);}";
    str += "  100% { -webkit-transform: rotate(" + (current_ang_gear[7]+move_ang_gear[7]*1) + "deg);}";
    stylesheet.addRule("@-webkit-keyframes escape_1", str );
    str  = "    0% { -webkit-transform: rotate(" + (current_ang_gear[5]+move_ang_gear[5]*0.75) + "deg);}";
    str += "   40% { -webkit-transform: rotate(" + (current_ang_gear[5]+move_ang_gear[5]*0.75) + "deg);}";
    str += "   60% { -webkit-transform: rotate(" + (current_ang_gear[5]+move_ang_gear[5]*1) + "deg);}";
    str += "  100% { -webkit-transform: rotate(" + (current_ang_gear[5]+move_ang_gear[5]*1) + "deg);}";
    stylesheet.addRule("@-webkit-keyframes gear4_1", str );
    str  = "    0% { -webkit-transform: rotate(" + (current_ang_gear[3]+move_ang_gear[3]*0.75) + "deg);}";
    str += "   40% { -webkit-transform: rotate(" + (current_ang_gear[3]+move_ang_gear[3]*0.75) + "deg);}";
    str += "   60% { -webkit-transform: rotate(" + (current_ang_gear[3]+move_ang_gear[3]*1) + "deg);}";
    str += "  100% { -webkit-transform: rotate(" + (current_ang_gear[3]+move_ang_gear[3]*1) + "deg);}";
    stylesheet.addRule("@-webkit-keyframes gear3_1", str );
    str  = "    0% { -webkit-transform: rotate(" + (current_ang_gear[1]+move_ang_gear[1]*0.75) + "deg);}";
    str += "   40% { -webkit-transform: rotate(" + (current_ang_gear[1]+move_ang_gear[1]*0.75) + "deg);}";
    str += "   60% { -webkit-transform: rotate(" + (current_ang_gear[1]+move_ang_gear[1]*1) + "deg);}";
    str += "  100% { -webkit-transform: rotate(" + (current_ang_gear[1]+move_ang_gear[1]*1) + "deg);}";
    stylesheet.addRule("@-webkit-keyframes gear2_1", str );
    str  = "    0% { -webkit-transform: rotate(" + (current_ang_gear[0]+move_ang_gear[0]*0.75) + "deg);}";
    str += "   40% { -webkit-transform: rotate(" + (current_ang_gear[0]+move_ang_gear[0]*0.75) + "deg);}";
    str += "   60% { -webkit-transform: rotate(" + (current_ang_gear[0]+move_ang_gear[0]*1) + "deg);}";
    str += "  100% { -webkit-transform: rotate(" + (current_ang_gear[0]+move_ang_gear[0]*1) + "deg);}";
    stylesheet.addRule("@-webkit-keyframes gear1_1", str );

    for(i=0; i<8; i++) {
      id_gear[i].className = gear_class_name[i] + "_move1";
      id_gear_s[i].className = gear_class_name[i] + "_move1";
      current_ang_gear[i] = (current_ang_gear[i] + move_ang_gear[i]) % 360;
    }
    id_anchors.className = "anchors_move1";
    id_anchors_shadow.className = "anchors_move1";
    id_escape_wheel.className = "escape_move1";
    id_escape_wheel_shadow.className = "escape_move1";
    id_balance.className = "balance_move1";
    id_balance_shadow.className = "balance_move1";
    for(i=0; i<6; i++) {
      id_hairspring[i].className = "hairspring" + i + "_move1";
      id_hairspring_s[i].className = "hairspring" + i + "_move1";
    }
    
  }
        
    
    id_second.addEventListener('transitionend',move_end,false);
    id_second.addEventListener('webkitTransitionEnd',move_end,false);
//    id_gear[0].addEventListener('webkitTransitionEnd',gear_move_end,false);
//    id_anchors.addEventListener('webkitAnimationEnd',anchors_move_end,false);
  cr_hours = get_date.getHours();
  h_angle = cr_hours*30 + cr_minutes/60*30;
  id_hour.style.transform = "rotate(" + h_angle + "deg)";
  id_hour.style.webkitTransform = "rotate(" + h_angle + "deg)";
//  setTimeout(setTime,100);
  
}
function anchors_move_end() {
  id_anchors.removeEventListener('webkitAnimationEnd',anchors_move_end,false);
  escape_angle = (escape_angle + 24) % 360;
  anime_flag = 1 - anime_flag;
  anchors_wait();
}
function anchors_wait() {
  id_balance.className = "anime_stay";
  id_escape_wheel.className = "anime_stay";
  id_escape_wheel.style.webkitTransform = "rotate(" + escape_angle + "deg)";
//  stylesheet.deleteRule(stylesheet.cssRules.length -1 );
}
function move_end() {
  id_second.removeEventListener('transitionend',move_end,false);
  id_second.removeEventListener('webkitTransitionEnd',move_end,false);
  wait();
}
function gear_move_end() {
  id_gear[0].removeEventListener('webkitTransitionEnd',move_end,false);
  gear_wait();
}
function wait() {
  id_second.className = "stay";
  id_minute.className = "stay";
  get_date = new Date();
  cr_hours = get_date.getHours();
	cr_minutes = get_date.getMinutes();
  cr_seconds = get_date.getSeconds();
  
  h_angle = cr_hours*30 + cr_minutes/60*30;
  id_hour.style.transform = "rotate(" + h_angle + "deg)";
  id_hour.style.webkitTransform = "rotate(" + h_angle + "deg)";
  m_angle = cr_minutes*6;
  id_minute.style.transform = "rotate(" + m_angle + "deg)";
  id_minute.style.webkitTransform = "rotate(" + m_angle + "deg)";
  s_angle = cr_seconds*6;
  id_second.style.transform = "rotate(" + s_angle + "deg)";
  id_second.style.webkitTransform = "rotate(" + s_angle + "deg)";
}
function gear_wait() {
  for(i=0; i<gear_num; i++) {	//gear_num
    id_gear[i].className = "stay";
    id_gear_s[i].className = "stay";
    current_ang_gear[i] = (current_ang_gear[i]+move_ang_gear[i]*dir_gear[i]) % 360;
    id_gear[i].style.webkitTransform = "rotate(" + current_ang_gear[i] + "deg)";
    id_gear_s[i].style.webkitTransform = "rotate(" + current_ang_gear[i] + "deg)";
  }
}



//　ゼンマイ描画
function draw_spring() {
  var PosX = 320;//描画の原点を取る位置(X座標)
  var PosY = 320;//描画の原点を取る位置(Y座標)
  var Interval = 120;//描画の細かさ
  var radius = 120;
  var variation = 2;//半径の変化量
  var X, Y;
  for(i=0; i<100; i++) {
    ctx = ctx_spring;
    ctx_s = ctx_spring_shadow;
    ctx.beginPath();
    ctx_s.beginPath();
    ctx.lineWidth = 1;
    ctx_s.lineWidth = 1;
    ctx.lineCap = "round"
    ctx_s.lineCap = "round"
    ctx.strokeStyle = "gray";
    ctx_s.shadowOffsetX = 0;
    ctx_s.shadowOffsetY = 0;
    ctx_s.shadowBlur = 2;
    ctx_s.shadowColor = "black";
    if(radius-variation*i < 5) break;
    ctx.moveTo(PosX,PosY-(radius-variation*i)*Math.cos(i*Math.PI));
    ctx_s.moveTo(PosX,PosY-(radius-variation*i)*Math.cos(i*Math.PI));
    for(k=0; k<Interval; k++) {
      ctx.lineTo(PosX + (radius-variation*(i+k/Interval))*Math.sin((i+k/Interval)*Math.PI),PosY - (radius-variation*(i+k/Interval))*Math.cos((i+k/Interval)*Math.PI));
      ctx_s.lineTo(PosX + (radius-variation*(i+k/Interval))*Math.sin((i+k/Interval)*Math.PI),PosY - (radius-variation*(i+k/Interval))*Math.cos((i+k/Interval)*Math.PI));
    }
    ctx.lineTo(PosX + (radius-variation*(i+1))*Math.sin((i+1)*Math.PI),PosY - (radius-variation*(i+1))*Math.cos((i+1)*Math.PI));
    ctx_s.lineTo(PosX + (radius-variation*(i+1))*Math.sin((i+1)*Math.PI),PosY - (radius-variation*(i+1))*Math.cos((i+1)*Math.PI));
    ctx.stroke();
    ctx_s.stroke();
  }
}












//　ヒゲゼンマイ描画
function draw_hairspring() {
  var X = new Array();
  X.length = 0;
  var Y = new Array();
  Y.length = 0;
  var PosX = 320;//描画の原点を取る位置(X座標)
  var PosY = 320;//描画の原点を取る位置(Y座標)
  var Interval = 120;//描画の細かさ
  var radius = 90;
  var variation = 7;//半径の変化量
  
  for(i=0; i<6; i++) {
    //    id_hairspring[i] = document.getElementById("hairspring"+i);
    //    id_hairspring_s[i] = document.getElementById("hairspring"+i+"_shadow");
    var ctx = id_hairspring[i].getContext("2d");
    ctx.beginPath();
    ctx.lineWidth = 3;
    ctx.lineCap = "round"
    var color1 = Math.floor((i+1)/4)*255;
    var color1_16 = "0" + color1.toString(16) + "0";
    color1_16 = color1_16.slice(-2);
    var color2 = Math.floor((i+1)/2)%2*255;
    var color2_16 = "0" + color2.toString(16) + "0";
    color2_16 = color2_16.slice(-2);
    var color3 = ((i+1)%2)*255;
    var color3_16 = "0" + color3.toString(16) + "0";
    color3_16 = color3_16.slice(-2);
    var color = "#" + color1_16 + color2_16 + color3_16;
    //    var color3 = Math.floor(Math.random()*255);
    color = "gray";
    ctx.strokeStyle = color;
    //    ctx.strokeStyle = "pink";
    //    ctx.fillStyle = "silver";
    //    ctx_s.fillStyle = "black";
    ctx.shadowOffsetX = 0;
    ctx.shadowOffsetY = 0;
    ctx.shadowBlur = 3;
    ctx.shadowColor = "silver";
    ctx.moveTo(PosX,PosY-(radius-variation*i)*Math.cos(i*Math.PI));
    for(k=0; k<Interval; k++) {
      ctx.lineTo(PosX + (radius-variation*(i+k/Interval))*Math.sin((i+k/Interval)*Math.PI),PosY - (radius-variation*(i+k/Interval))*Math.cos((i+k/Interval)*Math.PI));
    }
    ctx.lineTo(PosX + (radius-variation*(i+1))*Math.sin((i+1)*Math.PI),PosY - (radius-variation*(i+1))*Math.cos((i+1)*Math.PI));
    ctx.stroke();
  }
  ctx.lineTo(PosX ,PosY);
  ctx.stroke();
  
  
  for(i=0; i<6; i++) {
    //    id_hairspring[i] = document.getElementById("hairspring"+i);
    //    id_hairspring_s[i] = document.getElementById("hairspring"+i+"_shadow");
    var ctx_s = id_hairspring_s[i].getContext("2d");
    ctx_s.beginPath();
    ctx_s.lineWidth = 3;
    ctx_s.lineCap = "round"
    ctx_s.strokeStyle = "black";
    ctx_s.shadowColor = "black";
    ctx_s.shadowOffsetX = 0;
    ctx_s.shadowOffsetY = 0;
    ctx_s.shadowBlur = 0;
    ctx_s.moveTo(PosX,PosY-(radius-variation*i)*Math.cos(i*Math.PI));
    for(k=0; k<Interval; k++) {
      ctx_s.lineTo(PosX + (radius-variation*(i+k/Interval))*Math.sin((i+k/Interval)*Math.PI),PosY - (radius-variation*(i+k/Interval))*Math.cos((i+k/Interval)*Math.PI));
    }
    ctx_s.lineTo(PosX + (radius-variation*(i+1))*Math.sin((i+1)*Math.PI),PosY - (radius-variation*(i+1))*Math.cos((i+1)*Math.PI));
    ctx_s.stroke();
  }
  ctx_s.lineTo(PosX ,PosY);
  ctx_s.stroke();
  
  
}












//　テンプ描画
function draw_balance() {
  var Z = 15;//
  var M = 7;//
  //  var ctx = id_gear[id].getContext("2d");
  //  var ctx_s = id_gear_s[id].getContext("2d");
  var ctx = ctx_balance;
  var ctx_s = ctx_balance_shadow;
  var balance_r1 = 37;//
  var balance_r2 = 100;//
  var testAngle = 90;//50から130
  var InvoluteLineWidth = 1;//線の太さ
  var PosX = 320;//描画の原点を取る位置(X座標)
  var PosY = 320;//描画の原点を取る位置(Y座標)
  var t1 = 10;
  var t2 = 5;
  var X = new Array();
  X.length = 0;
  var Y = new Array();
  Y.length = 0;
  var i;
  var j;
  var k;
  
  
  //テンプの描画
  ctx.beginPath();
  ctx_s.beginPath();
  ctx.lineWidth = 0;
  ctx_s.lineWidth = InvoluteLineWidth;
  ctx.lineCap = "round"
  ctx_s.lineCap = "round"
  ctx.strokeStyle = "black";
  ctx_s.strokeStyle = "transparent";
  ctx.fillStyle = "silver";
  ctx_s.fillStyle = "black";
  ctx_s.shadowColor = "black";
  ctx_s.shadowOffsetX = 0;
  ctx_s.shadowOffsetY = 0;
  ctx_s.shadowBlur = 3;
  
  ctx.clearRect(0,0,640,640);
  ctx_s.clearRect(0,0,640,640);
  ctx.beginPath();
  ctx.fillStyle = "orange";
  ctx_s.beginPath();
  ctx_s.fillStyle = "black";
  for(i=0; i<12; i++){
    if(parseInt(i/3)%2 != 0){
      X[1] = PosX+(balance_r2+t1)*Math.cos((i*30-t2) * Math.PI/180);
      Y[1] = PosY+(balance_r2+t1)*Math.sin((i*30-t2) * Math.PI/180);
      X[2] = PosX+(balance_r2+t1)*Math.cos((i*30+t2) * Math.PI/180);
      Y[2] = PosY+(balance_r2+t1)*Math.sin((i*30+t2) * Math.PI/180);
      X[3] = PosX+(balance_r2+0)*Math.cos((i*30+t2) * Math.PI/180);
      Y[3] = PosY+(balance_r2+0)*Math.sin((i*30+t2) * Math.PI/180);
      X[4] = PosX+(balance_r2-t1-5)*Math.cos((i*30+0) * Math.PI/180);
      Y[4] = PosY+(balance_r2-t1-5)*Math.sin((i*30+0) * Math.PI/180);
      X[5] = PosX+(balance_r2+0)*Math.cos((i*30-t2) * Math.PI/180);
      Y[5] = PosY+(balance_r2+0)*Math.sin((i*30-t2) * Math.PI/180);
      ctx.moveTo(X[1], Y[1]);
      ctx.lineTo(X[2], Y[2]);
      ctx.lineTo(X[3], Y[3]);
      ctx.lineTo(X[4], Y[4]);
      ctx.lineTo(X[5], Y[5]);
      ctx.closePath;
      ctx_s.moveTo(X[1], Y[1]);
      ctx_s.lineTo(X[2], Y[2]);
      ctx_s.lineTo(X[3], Y[3]);
      ctx_s.lineTo(X[4], Y[4]);
      ctx_s.lineTo(X[5], Y[5]);
      ctx_s.closePath;
    }
  }
  ctx.stroke();
  ctx.fill();
  ctx_s.stroke();
  ctx_s.fill();
  
  ctx.beginPath();
  ctx.fillStyle = "silver";
  ctx.moveTo(PosX+balance_r2, PosY);
  ctx.arc(PosX, PosY, balance_r2, 0, 2 * Math.PI);
  ctx.moveTo(PosX+balance_r2-5, PosY);
  ctx.arc(PosX, PosY, balance_r2-5, 0, 2 * Math.PI, true);
  ctx.moveTo(PosX+balance_r1+10, PosY);
  ctx.arc(PosX, PosY, balance_r1+10, 0, 2 * Math.PI);
  ctx.stroke();
  ctx.fill();
  ctx_s.beginPath();
  ctx_s.fillStyle = "black";
  ctx_s.moveTo(PosX+balance_r2, PosY);
  ctx_s.arc(PosX, PosY, balance_r2, 0, 2 * Math.PI);
  ctx_s.moveTo(PosX+balance_r2-5, PosY);
  ctx_s.arc(PosX, PosY, balance_r2-5, 0, 2 * Math.PI, true);
  ctx_s.moveTo(PosX+balance_r1+10, PosY);
  ctx_s.arc(PosX, PosY, balance_r1+10, 0, 2 * Math.PI);
  ctx_s.stroke();
  ctx_s.fill();

  ctx.beginPath();
  ctx.strokeStyle = "black";
  ctx.fillStyle = "DeepPink";
  ctx.moveTo(PosX+5+balance_r1*Math.cos(testAngle * Math.PI/180), PosY+balance_r1*Math.sin(testAngle * Math.PI/180));
  ctx.arc(PosX+balance_r1*Math.cos(testAngle * Math.PI/180), PosY+balance_r1*Math.sin(testAngle * Math.PI/180), 4, 0, 360 * Math.PI/180);
  ctx.stroke();
  ctx.fill();
  
  
}












//　アンクル描画
function draw_anchors() {
  var Z = 15;//
  var M = 7;//
  //  var ctx = id_gear[id].getContext("2d");
  //  var ctx_s = id_gear_s[id].getContext("2d");
  var ctx = ctx_anchors;
  var ctx_s = ctx_anchors_shadow;
  var Radius = 50;//
  var RadiusLarge = Radius + 5;//
  var BladeAngle = 40;//歯の角度
  var InvoluteLineWidth = 0;//線の太さ
  var PosX = 320;//描画の原点を取る位置(X座標)
  var PosY = 320;//描画の原点を取る位置(Y座標)
  var t1 = 45;
  var t2 = 20;
  var X = new Array();
  X.length = 0;
  var Y = new Array();
  Y.length = 0;
  var i;
  var j;
  var k;
  var TempX;
  var TempY;
	var gcr = 3;
  
  //アンクル各ポイントの計算
  X[0] = PosX + 5;
  Y[0] = PosY - 10;
  X[1] = PosX + 40;
  Y[1] = PosY;
  X[2] = X[1] + 5;
  Y[2] = Y[1] - 5;
  X[3] = X[2] + 5;
  Y[3] = Y[2] - 5;
  X[4] = X[3] + 15;
  Y[4] = Y[3] + 15;
  X[5] = X[4] - 15;
  Y[5] = Y[4] + 15;
  X[6] = X[5] - 5;
  Y[6] = Y[5] - 5;
  X[7] = X[6] + 5;
  Y[7] = Y[6] - 5;
  X[8] = X[7] + 5;
  Y[8] = Y[7] - 5;
  X[9] = X[8] - 5;
  Y[9] = Y[8] - 5;
  X[10] = X[9] - 10;
  Y[10] = Y[9] + 10;
  X[11] = (PosX + X[10]) / 2;
  Y[11] = PosY;
  X[12] = PosX;//中央
  Y[12] = PosY + 10;//中央
  X[13] = 2*PosX - X[11];
  Y[13] = PosY;
  X[14] = 2*PosX - X[10] + 10;
  Y[14] = Y[10] - 5;
  X[15] = X[14] - 15*Math.cos((90-t2) * Math.PI/180);
  Y[15] = Y[14] - 15*Math.sin((90-t2) * Math.PI/180);
  X[16] = X[15] - 8*Math.cos((t2) * Math.PI/180);
  Y[16] = Y[15] + 8*Math.sin((t2) * Math.PI/180);
  X[17] = X[16] + 15*Math.cos((90-t2) * Math.PI/180);
  Y[17] = Y[16] + 15*Math.sin((90-t2) * Math.PI/180);
  X[18] = X[17] - 5*Math.cos((t2) * Math.PI/180);
  Y[18] = Y[17] + 5*Math.sin((t2) * Math.PI/180);
  X[19] = X[18] - 5*Math.cos((90-t2) * Math.PI/180);
  Y[19] = Y[18] - 5*Math.sin((90-t2) * Math.PI/180);
  X[20] = X[19] - 15*Math.cos((90-t2) * Math.PI/180);
  Y[20] = Y[19] - 15*Math.sin((90-t2) * Math.PI/180);
  X[21] = X[20] + 15*Math.cos((t2) * Math.PI/180);
  Y[21] = Y[20] - 15*Math.sin((t2) * Math.PI/180);
  X[22] = X[21] + 15*Math.cos((t2) * Math.PI/180);
  Y[22] = Y[21] + 15*Math.sin((t2) * Math.PI/180);
  X[23] = PosX - 5;
  Y[23] = PosY - 10;
  X[24] = PosX - 5;
  Y[24] = PosY - 30;
  X[25] = PosX - 5;
  Y[25] = PosY - 50;
  X[26] = X[25] - 10;
  Y[26] = Y[25] - 5;
  X[27] = X[26] + 5;
  Y[27] = Y[26] - 10;
  X[28] = X[27] - 5;
  Y[28] = Y[27] - 10;
  X[29] = X[28];
  Y[29] = Y[28] - 5;
  X[30] = X[29] + 10;
  Y[30] = Y[29] + 10;
  X[31] = PosX - 5;//ミゾ
  Y[31] = Y[30] + 16;//ミゾ
  X[32] = PosX + 5;//ミゾ
  Y[32] = Y[31];//ミゾ
  X[33] = X[32];
  Y[33] = Y[30];
  X[34] = X[33] + 10;
  Y[34] = Y[33] - 10;
  X[35] = X[34];
  Y[35] = Y[34] + 5;
  X[36] = X[35] - 5;
  Y[36] = Y[35] + 10;
  X[37] = X[36] + 5;
  Y[37] = Y[36] + 10;
  X[38] = X[37] - 10;
  Y[38] = Y[37] + 5;
  X[39] = PosX + 5;
  Y[39] = PosY - 50;
  X[40] = PosX + 5;
  Y[40] = PosY - 30;
  
  
  
  
  //アンクルの描画
  ctx.beginPath();
  ctx_s.beginPath();
  ctx.lineWidth = InvoluteLineWidth;
  ctx_s.lineWidth = InvoluteLineWidth;
  ctx.lineCap = "round"
  ctx_s.lineCap = "round"
  ctx.strokeStyle = "green";
  ctx_s.strokeStyle = "black";
  ctx.fillStyle = "silver";
  ctx_s.fillStyle = "black";
  ctx_s.shadowColor = "black";
  ctx_s.shadowOffsetX = 0;
  ctx_s.shadowOffsetY = 0;
  ctx_s.shadowBlur = 3;
  
  ctx.clearRect(0,0,640,640);
  ctx_s.clearRect(0,0,640,640);
  ctx.moveTo(X[0], Y[0]);
  ctx_s.moveTo(X[0], Y[0]);
  ctx.arcTo(X[0], Y[0], X[1], Y[1],5);
  ctx.arcTo(X[1], Y[1], X[2], Y[2],5);
  ctx.arcTo(X[2], Y[2], X[3], Y[3],5);
  ctx.arcTo(X[3], Y[3], X[4], Y[4],5);
  ctx.arcTo(X[4], Y[4], X[5], Y[5],5);
  ctx.arcTo(X[5], Y[5], X[6], Y[6],3);
  ctx.lineTo(X[6], Y[6]);
  ctx.lineTo(X[7], Y[7]);
  ctx.arcTo(X[8], Y[8], X[9], Y[9],3);
  ctx.lineTo(X[9], Y[9]);
  ctx.lineTo(X[10], Y[10]);
  ctx.arcTo(X[11], Y[11], X[12], Y[12],20);
  ctx.arcTo(X[12], Y[12], X[13], Y[13],10);
  ctx.arcTo(X[13], Y[13], X[14], Y[14],20);
  ctx.lineTo(X[14], Y[14]);
  ctx.lineTo(X[15], Y[15]);
  ctx.arcTo(X[16], Y[16], X[17], Y[17],3);
  ctx.lineTo(X[17], Y[17]);
  ctx.arcTo(X[18], Y[18], X[19], Y[19],3);
  ctx.lineTo(X[19], Y[19]);
  ctx.arcTo(X[20], Y[20], X[21], Y[21],3);
  ctx.arcTo(X[21], Y[21], X[22], Y[22],3);
  ctx.arcTo(X[22], Y[22], X[23], Y[23],10);
  ctx.arcTo(X[23], Y[23], X[24], Y[24],10);
  ctx.lineTo(X[24], Y[24]);
  ctx.arcTo(X[25], Y[25], X[26], Y[26],5);
  ctx.arcTo(X[26], Y[26], X[27], Y[27],5);
  ctx.arcTo(X[27], Y[27], X[28], Y[28],10);
  ctx.arcTo(X[28], Y[28], X[29], Y[29],10);
  ctx.lineTo(X[29], Y[29]);
  ctx.lineTo(X[30], Y[30]);
  ctx.lineTo(X[31], Y[31]);
  ctx.lineTo(X[32], Y[32]);
  ctx.lineTo(X[33], Y[33]);
  ctx.lineTo(X[34], Y[34]);
  ctx.arcTo(X[35], Y[35], X[36], Y[36], 10);
  ctx.arcTo(X[36], Y[36], X[37], Y[37], 10);
  ctx.arcTo(X[37], Y[37], X[38], Y[38], 5);
  ctx.arcTo(X[38], Y[38], X[39], Y[39], 5);
  ctx.arcTo(X[39], Y[39], X[40], Y[40], 5);
  ctx.lineTo(X[40], Y[40]);
  
  ctx.arcTo(X[0], Y[0], X[1], Y[1], 15);
  
  ctx_s.arcTo(X[0], Y[0], X[1], Y[1],5);
  ctx_s.arcTo(X[1], Y[1], X[2], Y[2],5);
  ctx_s.arcTo(X[2], Y[2], X[3], Y[3],5);
  ctx_s.arcTo(X[3], Y[3], X[4], Y[4],5);
  ctx_s.arcTo(X[4], Y[4], X[5], Y[5],5);
  ctx_s.arcTo(X[5], Y[5], X[6], Y[6],3);
  ctx_s.lineTo(X[6], Y[6]);
  ctx_s.lineTo(X[7], Y[7]);
  ctx_s.arcTo(X[8], Y[8], X[9], Y[9],3);
  ctx_s.lineTo(X[9], Y[9]);
  ctx_s.lineTo(X[10], Y[10]);
  ctx_s.arcTo(X[11], Y[11], X[12], Y[12],20);
  ctx_s.arcTo(X[12], Y[12], X[13], Y[13],10);
  ctx_s.arcTo(X[13], Y[13], X[14], Y[14],20);
  ctx_s.lineTo(X[14], Y[14]);
  ctx_s.lineTo(X[15], Y[15]);
  ctx_s.arcTo(X[16], Y[16], X[17], Y[17],3);
  ctx_s.lineTo(X[17], Y[17]);
  ctx_s.arcTo(X[18], Y[18], X[19], Y[19],3);
  ctx_s.lineTo(X[19], Y[19]);
  ctx_s.arcTo(X[20], Y[20], X[21], Y[21],3);
  ctx_s.arcTo(X[21], Y[21], X[22], Y[22],3);
  ctx_s.arcTo(X[22], Y[22], X[23], Y[23],10);
  ctx_s.arcTo(X[23], Y[23], X[24], Y[24],10);
  ctx_s.lineTo(X[24], Y[24]);
  ctx_s.arcTo(X[25], Y[25], X[26], Y[26],5);
  ctx_s.arcTo(X[26], Y[26], X[27], Y[27],5);
  ctx_s.arcTo(X[27], Y[27], X[28], Y[28],10);
  ctx_s.arcTo(X[28], Y[28], X[29], Y[29],10);
  ctx_s.lineTo(X[29], Y[29]);
  ctx_s.lineTo(X[30], Y[30]);
  ctx_s.lineTo(X[31], Y[31]);
  ctx_s.lineTo(X[32], Y[32]);
  ctx_s.lineTo(X[33], Y[33]);
  ctx_s.lineTo(X[34], Y[34]);
  ctx_s.arcTo(X[35], Y[35], X[36], Y[36], 10);
  ctx_s.arcTo(X[36], Y[36], X[37], Y[37], 10);
  ctx_s.arcTo(X[37], Y[37], X[38], Y[38], 5);
  ctx_s.arcTo(X[38], Y[38], X[39], Y[39], 5);
  ctx_s.arcTo(X[39], Y[39], X[40], Y[40], 5);
  ctx_s.lineTo(X[40], Y[40]);
  
  ctx_s.arcTo(X[0], Y[0], X[1], Y[1], 15);
  
  
  
  
  
  
  //  ctx.closePath();
  //  ctx_s.closePath();
  
  //空洞の描画
  ctx.lineWidth = InvoluteLineWidth;
  ctx_s.lineWidth = InvoluteLineWidth;
  ctx.lineCap = "round"
  ctx_s.lineCap = "round"
  ctx.strokeStyle = "black";
  ctx_s.strokeStyle = "black";
  ctx.fillStyle = "silver";
  ctx_s.fillStyle = "black";
  ctx_s.shadowColor = "black";
  ctx_s.shadowOffsetX = 0;
  ctx_s.shadowOffsetY = 0;
  ctx_s.shadowBlur = 2;
  
  ctx.moveTo(PosX+5, PosY);
  ctx.arc(PosX, PosY, 5, 0, 360 * Math.PI/180, true);
  ctx_s.moveTo(PosX+5, PosY);
  ctx_s.arc(PosX, PosY, 5, 0, 360 * Math.PI/180, true);
//  ctx.moveTo(PosX+5, PosY-54);
//  ctx.arc(PosX, PosY-54, 4, 0, 360 * Math.PI/180, true);
  
  ctx.stroke();
  ctx_s.stroke();
  ctx.fill();
  ctx_s.fill();
  
  //アンクルのツメ
  ctx.beginPath();
  ctx_s.beginPath();
  ctx.lineWidth = InvoluteLineWidth;
  ctx_s.lineWidth = InvoluteLineWidth;
  ctx.lineCap = "round"
  ctx_s.lineCap = "round"
  ctx.strokeStyle = "DeepPink";
  ctx_s.strokeStyle = "black";
  ctx.fillStyle = "DeepPink";
  ctx_s.fillStyle = "black";
  ctx_s.shadowColor = "black";
  ctx_s.shadowOffsetX = 0;
  ctx_s.shadowOffsetY = 0;
  ctx_s.shadowBlur = 3;
  
  ctx.moveTo(X[6]-1, Y[6]);
  ctx_s.moveTo(X[6], Y[6]);
  ctx.arcTo(X[6]-1+10*Math.cos((t1) * Math.PI/180),Y[6]-10*Math.sin((t1) * Math.PI/180),X[10]+1+9*Math.cos((t1) * Math.PI/180),Y[10]-9*Math.sin((t1) * Math.PI/180),5);
  ctx.lineTo(X[10]+1+9*Math.cos((t1) * Math.PI/180),Y[10]-9*Math.sin((t1) * Math.PI/180));
  ctx.lineTo(X[10]+1-10*Math.cos((t1) * Math.PI/180),Y[10]+10*Math.sin((t1) * Math.PI/180));
  ctx.lineTo(X[6]-1-12*Math.cos((t1) * Math.PI/180),Y[6]+12*Math.sin((t1) * Math.PI/180));
  ctx.closePath();
  ctx_s.arcTo(X[6]-1+10*Math.cos((t1) * Math.PI/180),Y[6]-10*Math.sin((t1) * Math.PI/180),X[10]+1+9*Math.cos((t1) * Math.PI/180),Y[10]-9*Math.sin((t1) * Math.PI/180),5);
  ctx_s.lineTo(X[10]+1+9*Math.cos((t1) * Math.PI/180),Y[10]-9*Math.sin((t1) * Math.PI/180));
  ctx_s.lineTo(X[10]+1-10*Math.cos((t1) * Math.PI/180),Y[10]+10*Math.sin((t1) * Math.PI/180));
  ctx_s.lineTo(X[6]-1-12*Math.cos((t1) * Math.PI/180),Y[6]+12*Math.sin((t1) * Math.PI/180));
  ctx_s.closePath();
  
  ctx.moveTo(X[17]+1, Y[17]);
  ctx_s.moveTo(X[17], Y[17]);
  ctx.arcTo(X[17]+1-10*Math.cos((90-t2) * Math.PI/180),Y[17]-10*Math.sin((90-t2) * Math.PI/180),X[14]-1-9*Math.cos((90-t2) * Math.PI/180),Y[14]-9*Math.sin((90-t2) * Math.PI/180),5);
  ctx.lineTo(X[14]-1-9*Math.cos((90-t2) * Math.PI/180),Y[14]-9*Math.sin((90-t2) * Math.PI/180));
  ctx.lineTo(X[14]-1+15*Math.cos((90-t2) * Math.PI/180),Y[14]+15*Math.sin((90-t2) * Math.PI/180));
  ctx.lineTo(X[17]+1+10*Math.cos((90-t2) * Math.PI/180),Y[17]+10*Math.sin((90-t2) * Math.PI/180));
  ctx.closePath();
  ctx_s.arcTo(X[17]+1-10*Math.cos((90-t2) * Math.PI/180),Y[17]-10*Math.sin((90-t2) * Math.PI/180),X[14]-1-9*Math.cos((90-t2) * Math.PI/180),Y[14]-9*Math.sin((90-t2) * Math.PI/180),5);
  ctx_s.lineTo(X[14]-1-9*Math.cos((90-t2) * Math.PI/180),Y[14]-9*Math.sin((90-t2) * Math.PI/180));
  ctx_s.lineTo(X[14]-1+12*Math.cos((90-t2) * Math.PI/180),Y[14]+12*Math.sin((90-t2) * Math.PI/180));
  ctx_s.lineTo(X[17]+1+10*Math.cos((90-t2) * Math.PI/180),Y[17]+10*Math.sin((90-t2) * Math.PI/180));
  ctx_s.closePath();
  
  
  
  
  ctx.stroke();
  ctx_s.stroke();
  ctx.fill();
  ctx_s.fill();
  
  
}












//　ガンギ車描画
function draw_escape_wheel(id) {
  var Z = 15;//ガンギ歯数
  var M = 7;//
  var ctx = ctx_escape_wheel;
  var ctx_s = ctx_escape_wheel_shadow;
  var Radius = 60;//
  var RadiusLarge = Radius + 5;//
  var BladeAngle = 40;//歯の角度
  var InvoluteLineWidth = 0;//線の太さ
  var PosX = 320;//描画の原点を取る位置(X座標)
  var PosY = 320;//描画の原点を取る位置(Y座標)
  
  var X = new Array();
  X.length = 0;
  var Y = new Array();
  Y.length = 0;
  var i;
  var j;
  var k;
  var TempX;
  var TempY;
	var gcr = 3;
  
  //ガンギ車各ポイントの計算
  X[0] = PosX + RadiusLarge;
  Y[0] = PosY;
  X[1] = X[0] + Radius/30*Math.cos((45-BladeAngle) * Math.PI/180);
  Y[1] = Y[0] - Radius/30*Math.sin((45-BladeAngle) * Math.PI/180);
  X[2] = X[1] + Radius/40*Math.cos((BladeAngle) * Math.PI/180);
  Y[2] = Y[1] + Radius/40*Math.sin((BladeAngle) * Math.PI/180);
  X[3] = X[2] + Radius/10*Math.cos((90+BladeAngle) * Math.PI/180);
  Y[3] = Y[2] + Radius/10*Math.sin((90+BladeAngle) * Math.PI/180);
  X[4] = X[3] + Radius/6*Math.cos((180+BladeAngle) * Math.PI/180);
  Y[4] = Y[3] + Radius/6*Math.sin((180+BladeAngle) * Math.PI/180);
  X[5] = X[4] + Radius/8*Math.cos((90+BladeAngle) * Math.PI/180);
  Y[5] = Y[4] + Radius/8*Math.sin((90+BladeAngle) * Math.PI/180);
  X[6] = (X[0] - PosX) * Math.cos(2/Z * Math.PI) - (Y[0] - PosY) * Math.sin(2/Z * Math.PI) + PosX - Radius/10*Math.cos((BladeAngle+20) * Math.PI/180);
  Y[6] = (X[0] - PosX) * Math.sin(2/Z * Math.PI) + (Y[0] - PosY) * Math.cos(2/Z * Math.PI) + PosY - Radius/10*Math.sin((BladeAngle+20) * Math.PI/180);
  
  X[7] = X[3] - Radius/5*Math.cos((BladeAngle) * Math.PI/180);
  Y[7] = Y[3] - Radius/5*Math.sin((BladeAngle) * Math.PI/180);
  X[8] = X[3] - Radius/3*Math.cos((BladeAngle) * Math.PI/180);
  Y[8] = Y[3] - Radius/3*Math.sin((BladeAngle) * Math.PI/180);
  X[9] = (X[8] - PosX) * Math.cos(1/Z * Math.PI) - (Y[8] - PosY) * Math.sin(1/Z * Math.PI) + PosX;
  Y[9] = (X[8] - PosX) * Math.sin(1/Z * Math.PI) + (Y[8] - PosY) * Math.cos(1/Z * Math.PI) + PosY;
  
  
  //ガンギ車の描画
  ctx.beginPath();
  ctx_s.beginPath();
  ctx.lineWidth = InvoluteLineWidth;
  ctx_s.lineWidth = InvoluteLineWidth;
  ctx.lineCap = "round"
  ctx_s.lineCap = "round"
  ctx.strokeStyle = "silver";
  ctx_s.strokeStyle = "black";
  ctx.fillStyle = "silver";
  ctx_s.fillStyle = "black";
  ctx_s.shadowColor = "black";
  ctx_s.shadowOffsetX = 0;
  ctx_s.shadowOffsetY = 0;
  ctx_s.shadowBlur = 3;
  
  ctx.clearRect(0,0,640,640);
  ctx_s.clearRect(0,0,640,640);

  ctx.moveTo(X[0], Y[0]);
  ctx_s.moveTo(X[0], Y[0]);
  for(j=0 ; j<Z ; j++){
    for(i=0 ; i<7 ; i++){
      if( i < 4 ) {
      	ctx.lineTo(X[i], Y[i]);
      	ctx_s.lineTo(X[i], Y[i]);
      }
      else if(i == 4){
        ctx.arcTo(X[4], Y[4], X[5], Y[5],5);
        ctx_s.arcTo(X[4], Y[4], X[5], Y[5],5);
        //              	ctx.lineTo(X[4], Y[4]);
        //      	ctx.lineTo(X[i], Y[i]);
      }
      else if(i == 5){
        ctx.arcTo(X[5], Y[5], X[6], Y[6],10);
        ctx_s.arcTo(X[5], Y[5], X[6], Y[6],10);
        //        ctx.lineTo(X[5], Y[5]);
        //        ctx.lineTo(X[6], Y[6]);
      }
      
      //次の描画用の回転処理
      last_X = X[i];
      last_Y = Y[i];
      TempX = (X[i] - PosX) * Math.cos(2/Z * Math.PI) - (Y[i] - PosY) * Math.sin(2/Z * Math.PI) + PosX;
      TempY = (X[i] - PosX) * Math.sin(2/Z * Math.PI) + (Y[i] - PosY) * Math.cos(2/Z * Math.PI) + PosY;
      X[i] = TempX;
      Y[i] = TempY;
    }
  }
  //  ctx.lineTo(X[0], Y[0]);
  //  ctx_s.lineTo(X[0], Y[0]);
  ctx.closePath();
  ctx_s.closePath();
  
  //空洞の描画
  //  ctx.beginPath();
  //  ctx_s.beginPath();
  ctx.lineWidth = InvoluteLineWidth;
  ctx_s.lineWidth = InvoluteLineWidth;
  ctx.lineCap = "round"
  ctx_s.lineCap = "round"
  ctx.strokeStyle = "black";
  ctx_s.strokeStyle = "black";
  ctx.fillStyle = "silver";
  ctx_s.fillStyle = "black";
  ctx_s.shadowColor = "black";
  ctx_s.shadowOffsetX = 0;
  ctx_s.shadowOffsetY = 0;
  ctx_s.shadowBlur = 2;
  
  for(j=0 ; j<Z ; j++){
    ctx.moveTo(X[7], Y[7]);
    ctx_s.moveTo(X[7], Y[7]);
    //    ctx.lineTo(X[8], Y[8]);
    //    ctx_s.lineTo(X[8], Y[8]);
    //    ctx.lineTo(X[9], Y[9]);
    //    ctx_s.lineTo(X[9], Y[9]);
    //    ctx.lineTo(X[7], Y[7]);
    //    ctx_s.lineTo(X[7], Y[7]);
    ctx.arcTo(X[8], Y[8], X[9], Y[9],1);
    ctx.arcTo(X[9], Y[9], X[7], Y[7],1);
    ctx.arcTo(X[7], Y[7], X[8], Y[8],5);
    ctx_s.arcTo(X[8], Y[8], X[9], Y[9],1);
    ctx_s.arcTo(X[9], Y[9], X[7], Y[7],1);
    ctx_s.arcTo(X[7], Y[7], X[8], Y[8],5);
    for(i=7 ; i<10 ; i++){
      //      	ctx.lineTo(X[i], Y[i]);
      //      	ctx_s.lineTo(X[i], Y[i]);
      
      //次の描画用の回転処理
      last_X = X[i];
      last_Y = Y[i];
      TempX = (X[i] - PosX) * Math.cos(2/Z * Math.PI) - (Y[i] - PosY) * Math.sin(2/Z * Math.PI) + PosX;
      TempY = (X[i] - PosX) * Math.sin(2/Z * Math.PI) + (Y[i] - PosY) * Math.cos(2/Z * Math.PI) + PosY;
      X[i] = TempX;
      Y[i] = TempY;
    }
  }
  //  ctx.closePath();
  //  ctx_s.closePath();
  
  
  
  
  
  
  //  ctx.moveTo(PosX-10, PosY);
  //  ctx.arc(PosX-20, PosY, 10, 0, Math.PI * 2, true);
  
  ctx.moveTo(PosX + 2*gcr, PosY - gcr);
  ctx.arc(PosX + gcr, PosY - gcr, Radius - 2*M - gcr, 0 * Math.PI/180, -90 * Math.PI/180, true);
  //  ctx.lineTo(PosX + gcr, PosY - 2*gcr);
  ctx.arc(PosX + gcr, PosY - gcr, 2*gcr, 90 * Math.PI/180, 0 * Math.PI/180, false);
  
  ctx.moveTo(PosX - gcr, PosY - 2*gcr);
  ctx.arc(PosX - gcr, PosY - gcr, Radius - 2*M - gcr, -90 * Math.PI/180, -180 * Math.PI/180, true);
  //  ctx.lineTo(PosX - 2*gcr, PosY - gcr);
  ctx.arc(PosX - gcr, PosY - gcr, 2*gcr, 180 * Math.PI/180, 90 * Math.PI/180, false);
  
  ctx.moveTo(PosX - 2*gcr, PosY + gcr);
  ctx.arc(PosX - gcr, PosY + gcr, Radius - 2*M - gcr, -180 * Math.PI/180, -270 * Math.PI/180, true);
  //  ctx.lineTo(PosX - gcr, PosY + 2*gcr);
  ctx.arc(PosX - gcr, PosY + gcr, 2*gcr, 270 * Math.PI/180, 180 * Math.PI/180, false);
  
  ctx.moveTo(PosX + gcr, PosY + 2*gcr);
  ctx.arc(PosX + gcr, PosY + gcr, Radius - 2*M - gcr, -270 * Math.PI/180, -360 * Math.PI/180, true);
  //  ctx.lineTo(PosX + 2*gcr, PosY + gcr);
  ctx.arc(PosX + gcr, PosY + gcr, 2*gcr, 360 * Math.PI/180, 270 * Math.PI/180, false);
  
  //  ctx.moveTo(PosX+30, PosY);
  //  ctx.arc(PosX+20, PosY, 10, 0, Math.PI * 2, true);
  //  ctx.moveTo(PosX+10, PosY-20);
  //  ctx.arc(PosX, PosY-20, 10, 0, Math.PI * 2, true);
  //  ctx.moveTo(PosX+10, PosY+20);
  //  ctx.arc(PosX, PosY+20, 10, 0, Math.PI * 2, true);
  ctx_s.moveTo(PosX + 2*gcr, PosY - gcr);
  ctx_s.arc(PosX + gcr, PosY - gcr, Radius - 2*M - gcr, 0 * Math.PI/180, -90 * Math.PI/180, true);
  //  ctx_s.lineTo(PosX + gcr, PosY - 2*gcr);
  ctx_s.arc(PosX + gcr, PosY - gcr, 2*gcr, 90 * Math.PI/180, 0 * Math.PI/180, false);
  
  ctx_s.moveTo(PosX - gcr, PosY - 2*gcr);
  ctx_s.arc(PosX - gcr, PosY - gcr, Radius - 2*M - gcr, -90 * Math.PI/180, -180 * Math.PI/180, true);
  //  ctx_s.lineTo(PosX - 2*gcr, PosY - gcr);
  ctx_s.arc(PosX - gcr, PosY - gcr, 2*gcr, 180 * Math.PI/180, 90 * Math.PI/180, false);
  
  ctx_s.moveTo(PosX - 2*gcr, PosY + gcr);
  ctx_s.arc(PosX - gcr, PosY + gcr, Radius - 2*M - gcr, -180 * Math.PI/180, -270 * Math.PI/180, true);
  //  ctx_s.lineTo(PosX - gcr, PosY + 2*gcr);
  ctx_s.arc(PosX - gcr, PosY + gcr, 2*gcr, 270 * Math.PI/180, 180 * Math.PI/180, false);
  
  ctx_s.moveTo(PosX + gcr, PosY + 2*gcr);
  ctx_s.arc(PosX + gcr, PosY + gcr, Radius - 2*M - gcr, -270 * Math.PI/180, -360 * Math.PI/180, true);
  //  ctx_s.lineTo(PosX + 2*gcr, PosY + gcr);
  ctx_s.arc(PosX + gcr, PosY + gcr, 2*gcr, 360 * Math.PI/180, 270 * Math.PI/180, false);
  
  ctx.stroke();
  ctx_s.stroke();
  ctx.fill();
  ctx_s.fill();
}













//　インボリュート歯車描画
function draw_gear(id,M) {//, M, Z, D) {
//  var M = 2;//モジュール
  //  var Z = 16;//歯数
  //  var D = 200;//M * Z;//ピッチ円直径
  D = M*z_gear[id]*1.2/2;
  //  M = D / Z;
  //  Z = D / M;
  var ctx = id_gear[id].getContext("2d");
  var ctx_s = id_gear_s[id].getContext("2d");
  var Da = D + 3*M/2;//刃先円直径
  var RadiusLarge = Da / 2;//刃先円半径
  var Db = D - 0;//2.5*M;//歯底直径
  var Radius = Db / 2;//歯底円半径
  var CogAngle = 1.1/z_gear[id] * Math.PI;//歯の厚さ(歯の底面が占める角度)
  var Interval = 360;//描画の細かさ
  var InvoluteLineWidth = 0;//Involuteの線の太さ
  var PosX = 320;//描画の原点を取る位置(X座標)
  var PosY = 320;//描画の原点を取る位置(Y座標)
  
  var Theta = 0;//媒介変数
  var X = new Array();
  X.length = 0;
  X[0] = PosX + Radius;
  var Y = new Array();
  Y.length = 0;
  Y[0] = PosY;
  var iX = new Array();
  iX.length = 0;
  iX[0] = PosX + Radius;
  var iY = new Array();
  iY.length = 0;
  iY[0] = PosY;
  var i;
  var j;
  var k;
  var TempX;
  var TempY;
	var gcr = 2;
  
  //--軌跡の計算
  Theta = 0;
  while(Math.pow(X[X.length-1]-PosX,2)+Math.pow(Y[Y.length-1]-PosY,2) < Math.pow(RadiusLarge,2)*1.05){
    X.push( PosX + Radius * (Math.cos(Theta) + Theta * Math.sin(Theta)));
    Y.push( PosY + Radius * (Math.sin(Theta) - Theta * Math.cos(Theta)));
    Theta += 2*Math.PI/Interval
  }
  X.push( PosX + Radius * (Math.cos(Theta) + Theta * Math.sin(Theta)));
  Y.push( PosY + Radius * (Math.sin(Theta) - Theta * Math.cos(Theta)));
  //反対側
  for(i=0 ; i<X.length ; i++){
    TempX = (X[i] - PosX) * Math.cos(CogAngle) + (Y[i] - PosY) * Math.sin(CogAngle) + PosX;
    TempY = (X[i] - PosX) * Math.sin(CogAngle) - (Y[i] - PosY) * Math.cos(CogAngle) + PosY;
    iX[X.length-i-1] = TempX;
    iY[Y.length-i-1] = TempY;
  }
  
  
  
  //--インボリュート歯車の描画
  ctx.beginPath();
  ctx_s.beginPath();
  ctx.lineWidth = InvoluteLineWidth;
  ctx_s.lineWidth = InvoluteLineWidth;
  ctx.lineCap = "round"
  ctx_s.lineCap = "round"
  ctx.strokeStyle = "black";
  ctx_s.strokeStyle = "transparent";
  ctx.fillStyle = "gold";
  ctx_s.fillStyle = "black";
  ctx_s.shadowColor = "black";
  ctx_s.shadowOffsetX = 0;
  ctx_s.shadowOffsetY = 0;
  ctx_s.shadowBlur = 3;
  
  ctx.moveTo(X[0], Y[0]);
  ctx_s.moveTo(X[0], Y[0]);
  for(j=0 ; j<z_gear[id] ; j++){
    for(i=0 ; i<X.length ; i++){
      ctx.lineTo(X[i], Y[i]);
      ctx_s.lineTo(X[i], Y[i]);
      
      //次の描画用の回転処理
      TempX = (X[i] - PosX) * Math.cos(2/z_gear[id] * Math.PI) - (Y[i] - PosY) * Math.sin(2/z_gear[id] * Math.PI) + PosX;
      TempY = (X[i] - PosX) * Math.sin(2/z_gear[id] * Math.PI) + (Y[i] - PosY) * Math.cos(2/z_gear[id] * Math.PI) + PosY;
      X[i] = TempX;
      Y[i] = TempY;
    }
    //裏側描画
    for(i=0 ; i<iX.length-1 ; i++){
      ctx.lineTo(iX[i], iY[i]);
      ctx_s.lineTo(iX[i], iY[i]);	      
      
      //次の描画用の回転処理
      TempX = (iX[i] - PosX) * Math.cos(2/z_gear[id] * Math.PI) - (iY[i] - PosY) * Math.sin(2/z_gear[id] * Math.PI) + PosX;
      TempY = (iX[i] - PosX) * Math.sin(2/z_gear[id] * Math.PI) + (iY[i] - PosY) * Math.cos(2/z_gear[id] * Math.PI) + PosY;
      last_iX = iX[i];
      last_iY = iY[i];
      iX[i] = TempX;
      iY[i] = TempY;
    }
    if(last_iY == Y[0]) {
      
    }
    else {
      TempX = (X[0] + last_iX) / 2 - PosX;
      TempY = (Y[0] + last_iY) / 2 - PosY;
      atan = Math.atan2(TempY, TempX);
      TempX = (Radius-M) * Math.cos(atan) + PosX;
      TempY = (Radius-M) * Math.sin(atan) + PosY;
    }
    ctx.arcTo(TempX, TempY, X[0], Y[0], M/2);
    ctx_s.arcTo(TempX, TempY, X[0], Y[0], M/2);
  }
  ctx.closePath();
  ctx_s.closePath();
  
  //  ctx.moveTo(PosX-10, PosY);
  //  ctx.arc(PosX-20, PosY, 10, 0, Math.PI * 2, true);
  
  ctx.moveTo(PosX + 2*gcr, PosY - gcr);
  ctx.arc(PosX + gcr, PosY - gcr, Radius - 2*M/2 - gcr, 0 * Math.PI/180, -90 * Math.PI/180, true);
  //  ctx.lineTo(PosX + gcr, PosY - 2*gcr);
  ctx.arc(PosX + gcr, PosY - gcr, 2*gcr, 90 * Math.PI/180, 0 * Math.PI/180, false);
  
  ctx.moveTo(PosX - gcr, PosY - 2*gcr);
  ctx.arc(PosX - gcr, PosY - gcr, Radius - 2*M/2 - gcr, -90 * Math.PI/180, -180 * Math.PI/180, true);
  //  ctx.lineTo(PosX - 2*gcr, PosY - gcr);
  ctx.arc(PosX - gcr, PosY - gcr, 2*gcr, 180 * Math.PI/180, 90 * Math.PI/180, false);
  
  ctx.moveTo(PosX - 2*gcr, PosY + gcr);
  ctx.arc(PosX - gcr, PosY + gcr, Radius - 2*M/2 - gcr, -180 * Math.PI/180, -270 * Math.PI/180, true);
  //  ctx.lineTo(PosX - gcr, PosY + 2*gcr);
  ctx.arc(PosX - gcr, PosY + gcr, 2*gcr, 270 * Math.PI/180, 180 * Math.PI/180, false);
  
  ctx.moveTo(PosX + gcr, PosY + 2*gcr);
  ctx.arc(PosX + gcr, PosY + gcr, Radius - 2*M/2 - gcr, -270 * Math.PI/180, -360 * Math.PI/180, true);
  //  ctx.lineTo(PosX + 2*gcr, PosY + gcr);
  ctx.arc(PosX + gcr, PosY + gcr, 2*gcr, 360 * Math.PI/180, 270 * Math.PI/180, false);
  
  //  ctx.moveTo(PosX+30, PosY);
  //  ctx.arc(PosX+20, PosY, 10, 0, Math.PI * 2, true);
  //  ctx.moveTo(PosX+10, PosY-20);
  //  ctx.arc(PosX, PosY-20, 10, 0, Math.PI * 2, true);
  //  ctx.moveTo(PosX+10, PosY+20);
  //  ctx.arc(PosX, PosY+20, 10, 0, Math.PI * 2, true);
  ctx_s.moveTo(PosX + 2*gcr, PosY - gcr);
  ctx_s.arc(PosX + gcr, PosY - gcr, Radius - 2*M/2 - gcr, 0 * Math.PI/180, -90 * Math.PI/180, true);
  //  ctx_s.lineTo(PosX + gcr, PosY - 2*gcr);
  ctx_s.arc(PosX + gcr, PosY - gcr, 2*gcr, 90 * Math.PI/180, 0 * Math.PI/180, false);
  
  ctx_s.moveTo(PosX - gcr, PosY - 2*gcr);
  ctx_s.arc(PosX - gcr, PosY - gcr, Radius - 2*M/2 - gcr, -90 * Math.PI/180, -180 * Math.PI/180, true);
  //  ctx_s.lineTo(PosX - 2*gcr, PosY - gcr);
  ctx_s.arc(PosX - gcr, PosY - gcr, 2*gcr, 180 * Math.PI/180, 90 * Math.PI/180, false);
  
  ctx_s.moveTo(PosX - 2*gcr, PosY + gcr);
  ctx_s.arc(PosX - gcr, PosY + gcr, Radius - 2*M/2 - gcr, -180 * Math.PI/180, -270 * Math.PI/180, true);
  //  ctx_s.lineTo(PosX - gcr, PosY + 2*gcr);
  ctx_s.arc(PosX - gcr, PosY + gcr, 2*gcr, 270 * Math.PI/180, 180 * Math.PI/180, false);
  
  ctx_s.moveTo(PosX + gcr, PosY + 2*gcr);
  ctx_s.arc(PosX + gcr, PosY + gcr, Radius - 2*M/2 - gcr, -270 * Math.PI/180, -360 * Math.PI/180, true);
  //  ctx_s.lineTo(PosX + 2*gcr, PosY + gcr);
  ctx_s.arc(PosX + gcr, PosY + gcr, 2*gcr, 360 * Math.PI/180, 270 * Math.PI/180, false);
  
  ctx.stroke();
  ctx_s.stroke();
  ctx.fill();
  ctx_s.fill();
}
